#  API REST


##  GLOBAL INFO 

### ENVIRONMENT VARIABLES :

```ini
API_NAME=<string>           # exemple "api1"
API_PORT=<number>           #( API port connexion, Default 3000 )   
MONGO_PORT=<number>         #( DB port connexion )    
MONGO_DB=<string>           #( DB name )       
MONGO_HOSTNAME=<string>     #( DB address connexion )  
```  

### RESPONSE FORMAT  :

* RESPONSE SUCCESS FORMAT  :
* 
```javascript
{success :{message : string}}
```
* RESPONSE ERROR FORMAT  : 
```javascript
{title : string, message : error.message}
```



# GUEST ENDPOINTS  : 




## Articles 
### OBJECT MODEL RECEIVED FROM API : 
```json 
{
   "titre":"string",
   "reference":"string",
   "contenu":"string",
   "photo":"string",
   "online":"boolean",
   "categorie":"string",
   "sousTitre":"string",
   "date":"Date"
}
```
### PING TEST :
*PING for test Api (without dataBase communication) :
>/<api_name>/articles/test
> 
### GET - getAll :
> /<api_name>/articles/getAll

### GET - getOneById :
> /<api_name>/articles/getOne/:id
* id : "article_id"

### GET - getByCategories :
> /<api_name>/articles/getByCategories/:id?number=5'
* id : 'autre' | 'achat' |'vente' |'location'| 'confiance'
* number : queryParams for number of articles

### GET - getLast :
> /<api_name>/articles/getLast


## Agence
### OBJECT MODEL RECEIVED FROM API : 
```json 
{
   "nomAgence":"string",
   "photos?":["string"],
   "fixe1":"number",
   "fixe2":"number",
   "portable":"number",
   "mail1":"string",
   "mail2":"string",
   "horraires":"string",
   "jours":"string",
   "presentation":"string",
   "address":{
      "country":"string",
      "region":"string",
      "city":"string",
      "street":"string",
      "postal_code":"string",
      "longitude":"number",
      "latitude":"number"
   },
   "gerant":{
      "nom":"string",
      "prenom":"string",
      "photo":"string",
    }
}
```
### GET - getAgenceInfos :
> /<api_name>/agence/getAgence


## Authentification
### OBJECT MODEL RECEIVED FROM API : 
```json 
{
   "_id":"string",
   "mail":"string",
   "mdp":"string",
   "sexe":"string",
   "nom":"string",
   "prenom":"string",
   "address":{
      "pays":"string",
      "ville":"string",
      "cp":"number",
      "rue":"string"
   },
   "phone":"number",
   "pub1?" :"boolean",
   "pub2?":"boolean",
   "isAdmin?":"boolean",
   "created_date":"Date"
}
```

### POST - Register : 
> /<api_name>/authentification/register
* body request :
```javascript
{
  mail : string,
  mdp : string,
  sexe : string,
  nom : string,
  prenom : string,
  pays : string,
  ville : string,
  cp : number,
  rue : string,
  phone : number,
  pub1? : boolean,
  pub2? : boolean,
}
```

### POST - Login : 
> /<api_name>/authentification/login
* body request :
```javascript
{
  mail : string,
  mdp : string,
}
```
* Response : 
```javascript
{
  token : string,
  success : {message : string},
  user : user,
}
```
* token content : 
```javascript
{
  userId : string,
  isAdmin: boolean,
  comeFrom : "immobilierApp"
}
```

### GET - getUserInformations : ( Need to be connected )
> /<api_name>/authentification/user/:id
* "id" : "user_id"


## Immobilier
### OBJECT MODEL RECEIVED FROM API: 
```json 
{
   "_id":"string",
   "mail":"string",
   "mdp":"string",
   "sexe":"string",
   "nom":"string",
   "prenom":"string",
   "address":{
      "pays":"string",
      "ville":"string",
      "cp":"number",
      "rue":"string"
   },
   "phone":"number",
   "pub1?" :"boolean",
   "pub2?":"boolean",
   "isAdmin?":"boolean",
   "created_date":"Date"
}
```

### GET - getAll : 
> /<api_name>/immobilier

### POST - getSomesByFilters :
> /<api_name>/immobilier/filter'
* status : "achat" or "location"
* body request : 

```javascript
{
        type?: ['local?', 'appartement?', 'maison?'],
        status?: ['achat?' | 'location?'],
        surface?: [min,max],
        price? : [min,max],
        bedroom?: number,
        bathroom?: number,
        living_room? : number,
        kitchen? : number,
        garage? : boolean,
        terrace? : boolean,
        region? : string,
        city?  : string,
        postal_code? : string,
}
```
### POST - get One Immo By Reference :
> /<api_name>/immobilier/findOne/:reference
* reference : "logement_reference" 

### POST - get Number Of Results By Filters :
> /<api_name>/immobilier/numberResults

* body request : 
```javascript
{
        type?: ['local?', 'appartement?', 'maison?'],
        surface?: [min,max],
        price? : [min,max],
        bedroom?: number,
        bathroom?: number,
        living_room? : number,
        kitchen? : number,
        garage? : boolean,
        terrace? : boolean,
        region? : string,
        city?  : string,
        postal_code? : string,
}
```

### GET - getLatestImmos : 
> /<api_name>/immobilier/getLast/:quantity
* quantity : number ('how many ?')

### POST - get all distinct value for one key : 
> /<api_name>/immobilier/getDistinct
* body request : 

```javascript
{ name : type | status | title | description | surface | price | bedroom | bathroom | living_room | kitchen | rooms | garage | terrace | country | region | city | street | postal_cod | longitude | latitude | date | sellerName | sellerFirstName | reference | offres |  banniere | photos | _id
}

```

# ADMIN ENDPOINTS  :

La différence des GETs Admin est qu'ils recupèrent + d'informations que les GETs User.

## Admin account
* mail : `admin@gmail.com`
* password : `admin`

## Immobilier Admin
### OBJECT MODEL RECEIVED FROM API: 
```json 
{
   "type":"string",
   "status":"string",
   "title":"string",
   "description":"string",
   "surface":"number",
   "price":"number",
   "bedroom":"number",
   "bathroom":"number",
   "living_room":"number",
   "kitchen":"number",
   "rooms":"number",
   "garage":"boolean",
   "terrace":"boolean",
   "address" : {
       "country":"string",
       "region":"string",
       "city":"string",
       "street":"string",
       "postal_code":"string",
       "longitude":"number",
       "latitude":"number",
   },
   "Date":Date,
   "sellerName":"string",
   "sellerFirstName?":"string",
   "reference":"string",
   "offres?":["string"],
   "banniere":"string",
   "photos":["string"],
   "_id":"string"
}
```

### GET - get all immos : 
> /<api_name>/admin/immo/getByFilter

### POST - get immos by admin filters  : 
> /<api_name>/admin/immo/getByFilter

### POST - Add one immo  : 
> /<api_name>/admin/immo/newImmo
* request type : FormData ( multipart/form-data )
* body request :
```javascript
{
    type: string,
    status: string,
    title: string,
    description: string,
    surface: number,
    price: number,
    bedroom: number,
    bathroom: number,
    living_room: number,
    kitchen: number,
    rooms: number,
    garage: boolean,
    terrace: boolean,
    country: string,
    region: string,
    city: string,
    street: string,
    postal_code: string,
    longitude: number,
    latitude: number,
    sellerName: string,
    sellerFirstName: string,
    img: file,
    imgs: [file],
    offres?:[string],
}
```


### DELETE - delete one   : 
> /<api_name>/admin/immo/delete/:reference
* reference : 'logement_reference'

### PUT - update one   : 
> /<api_name>/admin/immo/update/:reference
* reference : 'logement_reference'
* request type : FormData ( multipart/form-data )
* body request :
```javascript
{
   type: string,
   status: string,
   title: string,
   description: string,
   surface: number,
   price: number,
   bedroom: number,
   bathroom: number,
   living_room: number,
   kitchen: number,
   rooms: number,
   garage: boolean,
   terrace: boolean,
   country: string,
   region: string,
   city: string,
   street: string,
   postal_code: string,
   longitude: number,
   latitude: number,
   sellerName: string,
   sellerFirstName: string,
   img: file,
   imgs: [file],
   offres?:[string],
}
```

## ---Articles Admin ---
### OBJECT MODEL RECEIVED FROM API : 
```json 
{
   "titre":"string",
   "reference":"string",
   "contenu":"string",
   "photo":"string", //Banniere
   "online":"boolean",
   "categorie":"string",
   "sousTitre":"string",
   "date":"Date"
}
```

### GET - get All articles :
> /<api_name>/admin/articles/getAll

### POST - publish one article :
> /<api_name>/admin/articles/publish
* request type : FormData ( multipart/form-data )
* body request :
```javascript
{
   titre: string,
   contenu: string,
   img: file, //banniere
   imgs : [file], //Photo in articles 
   online: boolean,
   categorie: string, //listCategorie = ['autre','achat','vente','location','confiance']
   sousTitre: string,
}
```
ATTENTION : Les photos contenus dans le corp de l'article doivent être en base64 ET doivent AUSSI être contenues dans un Array\<File> avec le fieldName "imgs"


### PUT - edit one article :
> /<api_name>/admin/articles/update/:reference
* reference : 'article_reference'
* request type : FormData ( multipart/form-data )
* body request :
```javascript
{
    titre: string,
    contenu: string,
    img: file //banniere
    imgs : [file] //Photo in articles 
    online: boolean,
    categorie: string, //listCategorie = ['autre','achat','vente','location','confiance']
    sousTitre: string,
}
```
ATTENTION : Les photos contenues dans le corp de l'article doivent être en BASE64 ET doivent AUSSI être contenues dans un Array\<File> avec le fieldName "imgs"

### DELETE - delete one article :
> /<api_name>/admin/articles/delete/:reference
* reference : 'article_reference'

## ---Agence Admin ---
### POST - modify Agence Infos :
> /<api_name>/admin/agence/update

* body request : 

```javascript 
{
    nomAgence : string ,
    fixe1 : number,
    fixe2 : number,
    portable : number,
    mail1 : string,
    mail2 : string,
    horraires : string,
    jours : string,
    presentation : string,
    country: string,
    region : string,
    city  : string  ,
    street :  string  ,
    postal_code : string  ,
    longitude : number,
    latitude : number,
    nom : string,
    prenom : string,

    imgs? : [file] , //Photo de l'agence
    img? : file, //Photo du gerant
}
```
